import React, { Component } from 'react';
import axios from 'axios';
import { Link } from "react-router-dom";


const Quantity = props => (

    <tr>
        <td>{props.lessons.lessonno}</td>
        <td>{props.lessons.lessonname}</td>
        <td>{props.lessons.filename}</td>

        <td>
            <div>
                <span className=" mx-1 text-danger fas fa-trash" href='#' onClick={()=>{props.deleteProduct(props.lessons._id)}} ></span>
            </div>
        </td>
    </tr>
);


export default class QuestionBankUI extends Component {

    constructor(props) {
        super(props);
        this.deleteProduct = this.deleteProduct.bind(this);
        this.onSubmit = this.onSubmit.bind(this);

        this.state = {

            lessons: []
        }
    }

    quantityList() {
        return this.state.lessons.map(currentTodo => {
            return <Quantity lessons={currentTodo} deleteProduct={this.deleteProduct} key={currentTodo._id} />
        });
    }

    componentDidUpdate() {

        axios.get('http://localhost:5000/')
            .then(response => {
                this.setState({ lessons: response.data.images });
            })
            .catch(function (error) {
                console.log(error);
            })

    }

    componentDidMount() {

        axios.get('http://localhost:5000/')
            .then(response => {
                this.setState({ lessons: response.data.images });
            })
            .catch(function (error) {
                console.log(error);
            })


    }


    onSubmit(e) {
        e.preventDefault();


    }

    deleteProduct(pid){
        axios.delete('http://localhost:5000/delete/'+pid)
            .then(res => console.log(res.data));
        this.setState({
            lessons:this.state.lessons.filter(el => el.pid !==pid)
        });
    }

    render() {
        return (
            <div className="container text-left">
                <div className="col-sm-10" >


                    <hr />
                </div>



                <br/>

                <div className="col-sm-10">
                    <table className="table" >
                        <thead>
                        <tr>
                            <th><h6>Lesson No</h6></th>
                            <th><h6>Lesson Name</h6></th>
                            <th><h6>File Name</h6></th>
                            <th className="col-sm-1"><h6>Action </h6></th>
                        </tr>
                        </thead>
                        <tbody>
                        {this.quantityList()}
                        </tbody>
                    </table>
                </div>
            </div>
        )
    }
}